Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/Configuration.cs	(revision 14513)
@@ -1,109 +1,120 @@
-﻿using System.Collections.Generic;
-using HeuristicLab.Algorithms.PushGP.Expressions;
+﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
+  using System.Collections.Generic;
 
-namespace HeuristicLab.Algorithms.PushGP.Interpreter
-{
-    public class Configuration
-    {
-        public Configuration()
-        {
-            IsBooleanStackEnabled = true;
-            IsIntegerStackEnabled = true;
-            IsFloatStackEnabled = true;
-            IsCodeStackEnabled = true;
-            IsNameStackEnabled = true;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
 
-            EvalPushLimit = 4096;
-            MaxPointsInProgram = 128;
-            MaxPointsInRandomExpression = 1024;
+  public class Configuration {
+    public Configuration() {
+      this.IsBooleanStackEnabled = true;
+      this.IsIntegerStackEnabled = true;
+      this.IsFloatStackEnabled = true;
+      this.IsCodeStackEnabled = true;
+      this.IsNameStackEnabled = true;
 
-            TopLevelPushCode = true;
-            TopLevelPopCode = false;
+      this.EvalPushLimit = 4096;
+      this.MaxPointsInProgram = 128;
+      this.MaxPointsInRandomExpression = 1024;
 
-            RandomSeedMax = 30081;
-            RandomSeedMin = 0;
-            RandomSeed = null;
+      this.TopLevelPushCode = true;
+      this.TopLevelPopCode = false;
 
-            MinRandomInteger = -128;
-            MaxRandomInteger = 128;
-            MinRandomFloat = -128D;
-            MaxRandomFloat = 128D;
-            NewErcNameProbability = 0.5;
-        }
+      this.RandomSeedMax = 30081;
+      this.RandomSeedMin = 0;
+      this.RandomSeed = null;
 
-        public bool IsBooleanStackEnabled { get; set; }
-        public bool IsIntegerStackEnabled { get; set; }
-        public bool IsFloatStackEnabled { get; set; }
-        public bool IsCodeStackEnabled { get; set; }
-        public bool IsNameStackEnabled { get; set; }
+      this.MinRandomInteger = -128;
+      this.MaxRandomInteger = 128;
+      this.MinRandomFloat = -128D;
+      this.MaxRandomFloat = 128D;
+      this.NewErcNameProbability = 0.5;
+    }
 
-        public IList<string> AllowedInstructions { get; set; }
+    public bool IsBooleanStackEnabled { get; set; }
 
-        public IList<Expression> PredefinedExpressions { get; set; }
+    public bool IsIntegerStackEnabled { get; set; }
 
-        /// <summary>
-        /// This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
-        /// The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
-        /// as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
-        /// When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
-        /// to the abort (so they may still be examined by a calling program). Whether or not this counts as an "abnormal" termination
-        /// is up to the calling program.
-        /// </summary>
-        public uint EvalPushLimit { get; set; }
+    public bool IsFloatStackEnabled { get; set; }
 
-        /// <summary>
-        /// This is the maximum size of an item on the CODE stack, expressed as a number of points.
-        /// A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be exceeded
-        /// should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the instruction.
-        /// </summary>
-        public uint MaxPointsInProgram { get; set; }
+    public bool IsCodeStackEnabled { get; set; }
 
-        /// <summary>
-        /// The maximum number of points in an expression produced by the CODE.RAND instruction.
-        /// </summary>
-        public uint MaxPointsInRandomExpression { get; set; }
+    public bool IsNameStackEnabled { get; set; }
 
-        /// <summary>
-        /// When TRUE (which is the default), code passed to the top level of the interpreter
-        /// will be pushed onto the CODE stack prior to execution.
-        /// </summary>
-        public bool TopLevelPushCode { get; set; }
+    public IList<string> AllowedInstructions { get; set; }
 
-        /// <summary>
-        /// When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
-        /// </summary>
-        public bool TopLevelPopCode { get; set; }
+    public IList<Expression> PredefinedExpressions { get; set; }
 
-        /// <summary>
-        /// The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
-        /// </summary>
-        public int MinRandomInteger { get; set; }
+    /// <summary>
+    ///     This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
+    ///     The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
+    ///     as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
+    ///     When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
+    ///     to the abort (so they may still be examined by a calling program). Whether or not this counts as an "abnormal"
+    ///     termination
+    ///     is up to the calling program.
+    /// </summary>
+    public int EvalPushLimit { get; set; }
 
-        /// <summary>
-        /// The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
-        /// </summary>
-        public int MaxRandomInteger { get; set; }
+    /// <summary>
+    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// </summary>
+    public int MaxDepth { get; set; }
 
-        /// <summary>
-        /// The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
-        /// </summary>
-        public double MinRandomFloat { get; set; }
+    /// <summary>
+    ///     This is the maximum size of an item on the CODE stack, expressed as a number of points.
+    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
+    ///     exceeded
+    ///     should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     instruction.
+    /// </summary>
+    public int MaxPointsInProgram { get; set; }
 
-        /// <summary>
-        /// The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
-        /// </summary>
-        public double MaxRandomFloat { get; set; }
+    /// <summary>
+    ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
+    /// </summary>
+    public int MaxPointsInRandomExpression { get; set; }
 
-        /// <summary>
-        /// The probability that the selection of the ephemeral
-        /// random NAME constant for inclusion in randomly generated code will produce a new name
-        /// (rather than a name that was previously generated).
-        /// </summary>
-        public double NewErcNameProbability { get; set; }
+    /// <summary>
+    ///     When TRUE (which is the default), code passed to the top level of the interpreter
+    ///     will be pushed onto the CODE stack prior to execution.
+    /// </summary>
+    public bool TopLevelPushCode { get; set; }
 
-        public ushort RandomSeedMax { get; set; }
-        public ushort RandomSeedMin { get; set; }
+    /// <summary>
+    ///     When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
+    /// </summary>
+    public bool TopLevelPopCode { get; set; }
 
-        public ushort? RandomSeed { get; set; }
-    }
+    /// <summary>
+    ///     The minimum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
+    /// </summary>
+    public int MinRandomInteger { get; set; }
+
+    /// <summary>
+    ///     The maximum INTEGER that will be produced as an ephemeral random INTEGER constant or from a call to INTEGER.RAND.
+    /// </summary>
+    public int MaxRandomInteger { get; set; }
+
+    /// <summary>
+    ///     The minimum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
+    /// </summary>
+    public double MinRandomFloat { get; set; }
+
+    /// <summary>
+    ///     The maximum FLOAT that will be produced as an ephemeral random FLOAT constant or from a call to FLOAT.RAND.
+    /// </summary>
+    public double MaxRandomFloat { get; set; }
+
+    /// <summary>
+    ///     The probability that the selection of the ephemeral
+    ///     random NAME constant for inclusion in randomly generated code will produce a new name
+    ///     (rather than a name that was previously generated).
+    /// </summary>
+    public double NewErcNameProbability { get; set; }
+
+    public ushort RandomSeedMax { get; set; }
+
+    public ushort RandomSeedMin { get; set; }
+
+    public ushort? RandomSeed { get; set; }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/IPushGpInterpreter.cs	(revision 14513)
@@ -0,0 +1,48 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
+  using System;
+  using System.Collections.Generic;
+  using System.Threading;
+  using System.Threading.Tasks;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Stack;
+
+  public interface IPushGpInterpreter {
+    IStack<Expression> CodeStack { get; }
+
+    IStack<Expression> ExecStack { get; }
+
+    IStack<string> NameStack { get; }
+
+    IStack<bool> BooleanStack { get; }
+
+    IStack<long> IntegerStack { get; }
+
+    IStack<double> FloatStack { get; }
+
+    IDictionary<string, Expression> CustomExpressions { get; }
+
+    Configuration Configuration { get; }
+
+    bool IsNameQuoteFlagSet { get; set; }
+
+    void Interpret(string code);
+
+    Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken));
+
+    void Interpret(Expression program);
+
+    Task InterpretAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken));
+
+    Task AbortAndResetAsync();
+
+    Task AbortAsync();
+
+    Task PauseAsync();
+
+    Task ResumeAsync();
+
+    void Step();
+
+    void PrintStacks();
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PooledPushGpInterpreter.cs	(revision 14513)
@@ -0,0 +1,24 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
+  using System;
+
+  using HeuristicLab.Algorithms.PushGP.Data.Pool;
+
+  public class PooledPushGpInterpreter : PushGpInterpreter, IRecyclable, IDisposable {
+
+    private readonly PushGpInterpreterPool container;
+
+    public PooledPushGpInterpreter(PushGpInterpreterPool container, Configuration config)
+      : base(config) {
+      this.container = container;
+    }
+
+    void IRecyclable.Recycle() {
+      this.Reset();
+      this.Configuration = this.container.Configuration;
+    }
+
+    public void Dispose() {
+      this.container.Free(this);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGPInterpreter.cs	(revision 14513)
@@ -1,247 +1,223 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Threading;
-using System.Threading.Tasks;
-using HeuristicLab.Algorithms.PushGP.Expressions;
-using HeuristicLab.Algorithms.PushGP.Generators;
-using HeuristicLab.Algorithms.PushGP.Stack;
-
-namespace HeuristicLab.Algorithms.PushGP.Interpreter
-{
-    public class PushGPInterpreter : IInterpreter
+﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
+  using System;
+  using System.Collections.Generic;
+  using System.Threading;
+  using System.Threading.Tasks;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Parser;
+  using HeuristicLab.Algorithms.PushGP.Stack;
+
+  public class PushGpInterpreter : IPushGpInterpreter {
+    private Task currentTask;
+
+    public PushGpInterpreter(Configuration config = null) {
+      this.Configuration = config ?? new Configuration();
+
+      // setting the capacity of the stacks to max points ensures that there will be enough memory at runtime
+      this.CodeStack = new PushGPStack<Expression>(this.Configuration.MaxPointsInProgram);
+      this.ExecStack = new PushGPStack<Expression>(this.Configuration.MaxPointsInProgram);
+      this.NameStack = new PushGPStack<string>(16);
+      this.BooleanStack = new PushGPStack<bool>(16);
+      this.IntegerStack = new PushGPStack<long>(16);
+      this.FloatStack = new PushGPStack<double>(16);
+
+      this.CustomExpressions = new Dictionary<string, Expression>();
+    }
+
+    public int ExecCounter { get; private set; }
+
+    public bool IsPaused { get; private set; }
+
+    public bool IsAborted { get; private set; }
+
+    public bool IsRunning
     {
-        private Task currentTask;
-
-
-        public PushGPInterpreter(Configuration config = null)
-        {
-            Configuration = config ?? new Configuration();
-
-            CodeStack = new PushGPStack<Expression>(128);
-            ExecStack = new PushGPStack<Expression>(128);
-            NameStack = new PushGPStack<string>(16);
-            BooleanStack = new PushGPStack<bool>(16);
-            IntegerStack = new PushGPStack<long>(16);
-            FloatStack = new PushGPStack<double>(16);
-
-            CustomExpressions = new Dictionary<string, Expression>();
-
-            CodeGenerator = new CodeGenerator(this);
-        }
-
-        public Configuration Configuration { get; private set; }
-
-        public int ExecCounter { get; private set; }
-        public bool IsPaused { get; private set; }
-        public bool IsAborted { get; private set; }
-        public bool IsRunning { get { return ExecStack.Count > 0 && !IsPaused && !IsAborted && ExecCounter < Configuration.EvalPushLimit; } }
-        public bool IsCompleted { get { return ExecStack.Count == 0; } }
-        public bool CanStep { get { return !IsCompleted && !IsAborted && IsPaused; } }
-
-        public IStack<Expression> CodeStack { get; private set; }
-        public IStack<Expression> ExecStack { get; private set; }
-        public IStack<string> NameStack { get; private set; }
-        public IStack<bool> BooleanStack { get; private set; }
-        public IStack<long> IntegerStack { get; private set; }
-        public IStack<double> FloatStack { get; private set; }
-
-        public IDictionary<string, Expression> CustomExpressions { get; private set; }
-
-        public CodeGenerator CodeGenerator { get; private set; }
-
-        public bool IsNameQuoteFlagSet { get; set; }
-
-        public void Reset()
-        {
-            IsAborted = false;
-            IsPaused = false;
-            currentTask = null;
-
-            Clear();
-        }
-
-        public void Clear()
-        {
-            ExecCounter = 0;
-
-            ExecStack.Clear();
-            CodeStack.Clear();
-            NameStack.Clear();
-            BooleanStack.Clear();
-            IntegerStack.Clear();
-            FloatStack.Clear();
-
-            CustomExpressions.Clear();
-        }
-
-        public void Interpret(string code)
-        {
-            var program = Encode(code);
-            Interpret(program);
-        }
-
-        public Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken))
-        {
-            var program = Encode(code);
-
-            currentTask = InterpretAsync(program, paused, token);
-
-            return currentTask;
-        }
-
-        public Task InterpretAsync(Expression program, bool paused = false, CancellationToken token = default(CancellationToken))
-        {
-            IsPaused = paused;
-            currentTask = Task.Run(() => Interpret(program), token);
-
-            return currentTask;
-        }
-
-        public void Interpret(Expression program)
-        {
-            /* Push top expression so the loop is able to enter
-             * If the top expression is a single statement then the loop has nothing to do
-             * Otherwise the expand expression will be evaluated and pushes code onto the EXEC stack */
-            ExecStack.Push(program);
-
-            if (Configuration.TopLevelPushCode)
-            {
-                CodeStack.Insert(0, program);
-            }
-
-            // run top expression
-            ExecStack.Pop().Eval(this);
-
-            Interpret();
-        }
-
-        private void Interpret()
-        {
-            while (IsRunning)
-            {
-                DoStep();
-                ExecCounter++;
-            }
-
-            Finally();
-        }
-
-        private void Finally()
-        {
-            if (IsCompleted && Configuration.TopLevelPopCode && CodeStack.Count > 0)
-            {
-                CodeStack.Pop();
-            }
-        }
-
-        private void DoStep()
-        {
-            ExecStack.Pop().Eval(this);
-        }
-
-        private Task InterpreteAsync()
-        {
-            currentTask = Task.Run(() => Interpret());
-
-            return currentTask;
-        }
-
-        public async Task AbortAsync()
-        {
-            if (IsAborted || IsCompleted)
-                return;
-
-            IsAborted = true;
-
-            if (currentTask != null)
-            {
-                await currentTask;
-            }
-        }
-
-        public async Task AbortAndResetAsync()
-        {
-            await AbortAsync();
-            Reset();
-        }
-
-        public async Task PauseAsync()
-        {
-            if (IsPaused || IsCompleted)
-                return;
-
-            IsPaused = true;
-
-            if (currentTask != null)
-            {
-                await currentTask;
-            }
-        }
-
-        public Task ResumeAsync()
-        {
-            if (IsPaused || !IsAborted)
-            {
-                IsPaused = false;
-                return InterpreteAsync();
-            }
-
-            return currentTask;
-        }
-
-        public void Step()
-        {
-            if (CanStep)
-            {
-                DoStep();
-                Finally();
-            }
-        }
-
-        public void Step(int count)
-        {
-            for (var i = 0; i < count; i++)
-            {
-                Step();
-            }
-        }
-
-        public static Expression Encode(string code)
-        {
-            return Parser.Parse(code);
-        }
-
-        public static Task<Expression> EncodeAsync(string code, CancellationToken token = default(CancellationToken))
-        {
-            return Task.Run(() => Encode(code), token);
-        }
-
-        public static string Decode(Expression expression)
-        {
-            return string.Concat(expression.ToString());
-        }
-
-        public static Task<string> DecodeAsync(Expression expression, CancellationToken token = default(CancellationToken))
-        {
-            return Task.Run(() => Decode(expression), token);
-        }
-
-        public void PrintStacks()
-        {
-            PrintStack("EXEC", ExecStack);
-            PrintStack("CODE", CodeStack);
-            PrintStack("NAME", NameStack);
-            PrintStack("BOOLEAN", BooleanStack);
-            PrintStack("FLOAT", FloatStack);
-            PrintStack("INTEGER", IntegerStack);
-        }
-
-        private void PrintStack<T>(string name, IStack<T> stack)
-        {
-            Console.WriteLine(string.Format(
-                "--- {0} ---\n{1}\n---------------------------------------------------",
-                name,
-                stack));
-        }
-    }
+      get
+      {
+        return !this.ExecStack.IsEmpty &&
+               !this.IsPaused &&
+               !this.IsAborted &&
+               (this.ExecCounter < this.Configuration.EvalPushLimit);
+      }
+    }
+
+    public bool IsCompleted
+    {
+      get
+      {
+        return this.ExecStack.Count == 0;
+      }
+    }
+
+    public bool CanStep
+    {
+      get
+      {
+        return !this.IsCompleted && !this.IsAborted && this.IsPaused;
+      }
+    }
+
+    public Configuration Configuration { get; protected set; }
+
+    public IStack<Expression> CodeStack { get; private set; }
+
+    public IStack<Expression> ExecStack { get; private set; }
+
+    public IStack<string> NameStack { get; private set; }
+
+    public IStack<bool> BooleanStack { get; private set; }
+
+    public IStack<long> IntegerStack { get; private set; }
+
+    public IStack<double> FloatStack { get; private set; }
+
+    public IDictionary<string, Expression> CustomExpressions { get; private set; }
+
+    public bool IsNameQuoteFlagSet { get; set; }
+
+    public void Interpret(string code) {
+      var program = PushGPParser.Parse(code);
+      this.Interpret(program);
+    }
+
+    public Task InterpretAsync(string code, bool paused = false, CancellationToken token = default(CancellationToken)) {
+      var program = PushGPParser.Parse(code);
+
+      this.currentTask = this.InterpretAsync(program, paused, token);
+
+      return this.currentTask;
+    }
+
+    public Task InterpretAsync(
+      Expression program,
+      bool paused = false,
+      CancellationToken token = default(CancellationToken)) {
+      this.IsPaused = paused;
+      this.currentTask = Task.Run(() => this.Interpret(program), token);
+
+      return this.currentTask;
+    }
+
+    public void Interpret(Expression program) {
+      /* Push top expression so the loop is able to enter
+       * If the top expression is a single statement then the loop has nothing to do
+       * Otherwise the expand expression will be evaluated and pushes code onto the EXEC stack */
+      this.ExecStack.Push(program);
+
+      if (this.Configuration.TopLevelPushCode) this.CodeStack.Insert(0, program);
+
+      // run top expression
+      this.DoStep();
+
+      this.Interpret();
+    }
+
+    public async Task AbortAsync() {
+      if (this.IsAborted || this.IsCompleted) return;
+
+      this.IsAborted = true;
+
+      if (this.currentTask != null) await this.currentTask;
+    }
+
+    public async Task AbortAndResetAsync() {
+      await this.AbortAsync();
+      this.Reset();
+    }
+
+    public async Task PauseAsync() {
+      if (this.IsPaused || this.IsCompleted) return;
+
+      this.IsPaused = true;
+
+      if (this.currentTask != null) await this.currentTask;
+    }
+
+    public Task ResumeAsync() {
+      if (this.IsPaused || !this.IsAborted) {
+        this.IsPaused = false;
+        return this.InterpreteAsync();
+      }
+
+      return this.currentTask;
+    }
+
+    public void Step() {
+      if (!this.CanStep) return;
+      this.DoStep();
+      this.Finally();
+    }
+
+    public void Step(int count) {
+      for (var i = 0; i < count; i++) this.Step();
+    }
+
+    public void PrintStacks() {
+      this.PrintStack("EXEC", this.ExecStack);
+      this.PrintStack("CODE", this.CodeStack);
+      this.PrintStack("NAME", this.NameStack);
+      this.PrintStack("BOOLEAN", this.BooleanStack);
+      this.PrintStack("FLOAT", this.FloatStack);
+      this.PrintStack("INTEGER", this.IntegerStack);
+    }
+
+    /// <summary>
+    /// Clears stacks and
+    /// </summary>
+    public void Reset() {
+      this.IsAborted = false;
+      this.IsPaused = false;
+      this.currentTask = null;
+
+      this.Clear();
+    }
+
+    /// <summary>
+    /// Clears stacks
+    /// </summary>
+    public void Clear() {
+      this.ExecCounter = 0;
+
+      this.ExecStack.Clear();
+      this.CodeStack.Clear();
+
+      this.NameStack.Clear();
+      this.BooleanStack.Clear();
+      this.IntegerStack.Clear();
+      this.FloatStack.Clear();
+
+      this.CustomExpressions.Clear();
+    }
+
+    private void Interpret() {
+      while (this.IsRunning) {
+        this.DoStep();
+        this.ExecCounter++;
+      }
+
+      this.Finally();
+    }
+
+    private void Finally() {
+      if (!this.IsCompleted)
+        return;
+
+      if (this.Configuration.TopLevelPopCode && (this.CodeStack.Count > 0))
+        this.CodeStack.Pop();
+    }
+
+    private void DoStep() {
+      this.ExecStack.Pop().Eval(this);
+    }
+
+    private Task InterpreteAsync() {
+      this.currentTask = Task.Run(() => this.Interpret());
+
+      return this.currentTask;
+    }
+
+    private void PrintStack<T>(string name, IStack<T> stack) {
+      Console.WriteLine("--- {0} ---\n{1}\n---------------------------------------------------", name, stack);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGpInterpreterPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGpInterpreterPool.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Interpreter/PushGpInterpreterPool.cs	(revision 14513)
@@ -0,0 +1,29 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Interpreter {
+  using System;
+
+  using HeuristicLab.Algorithms.PushGP.Data.Pool;
+
+  public class PushGpInterpreterPool {
+    private readonly ObjectPool<PooledPushGpInterpreter> pool;
+
+    public PushGpInterpreterPool(Configuration config = null)
+      : this(Environment.ProcessorCount * 2, config) {
+    }
+
+    public PushGpInterpreterPool(int size, Configuration config = null) {
+      Configuration = config ?? new Configuration();
+
+      pool = new ObjectPool<PooledPushGpInterpreter>(() => new PooledPushGpInterpreter(this, Configuration), size);
+    }
+
+    public Configuration Configuration { get; private set; }
+
+    public PooledPushGpInterpreter GetInstance() {
+      return pool.Allocate();
+    }
+
+    public void Free(PooledPushGpInterpreter interpreter) {
+      pool.Free(interpreter);
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/PushGPParser.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/PushGPParser.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Parser/PushGPParser.cs	(revision 14513)
@@ -0,0 +1,92 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Parser {
+  using System.Collections.Generic;
+  using System.Globalization;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+
+  public static class PushGPParser {
+    private const string openBrace = "(";
+
+    private const string closeBrace = ")";
+
+    private const char delimiter = ' ';
+
+    private static readonly CultureInfo cultureInfo = CultureInfo.CreateSpecificCulture("en-US");
+
+    private static readonly char[] symbolTrim = { '\r', '\n' };
+
+    public static Expression Parse(string source, int startIndex = 0) {
+      var symbols = source.Split(delimiter);
+
+      int endIndex;
+      return Parse(symbols, 0, out endIndex);
+    }
+
+    private static Expression Parse(string[] symbols, int startIndex, out int endIndex) {
+      var expressions = new List<Expression>();
+
+      for (var i = startIndex; i < symbols.Length; i++) {
+        var symbol = symbols[i].TrimEnd(symbolTrim);
+
+        if (string.IsNullOrWhiteSpace(symbol)) continue;
+
+        switch (symbol) {
+          case openBrace:
+            var subExpression = Parse(symbols, i + 1, out endIndex);
+            expressions.Insert(0, subExpression);
+            i = endIndex;
+            continue;
+          case closeBrace:
+            endIndex = i;
+            return new ExecExpandExpression(expressions.ToArray());
+        }
+
+        // literal
+        Expression expression;
+        if (TryParseLiteral(symbol, out expression)) {
+          expressions.Insert(0, expression);
+          continue;
+        }
+
+        // expression
+        if (ExpressionTable.TryGetStatelessExpression(symbol, out expression)
+            || ExpressionTable.TryGetStatefullExpression(symbol, out expression)) {
+          expressions.Insert(0, expression);
+          continue;
+        }
+
+        // identifier - custom expression or named literals
+        expressions.Insert(0, new NameDefineXExecExpression(symbol));
+      }
+
+      endIndex = symbols.Length - 1;
+
+      return expressions.Count == 1
+        ? expressions[0]
+        : new ExecExpandExpression(expressions.ToArray());
+    }
+
+    private static bool TryParseLiteral(string word, out Expression expression) {
+      long longValue;
+      if (long.TryParse(word, out longValue)) {
+        expression = new IntegerPushExpression(longValue);
+        return true;
+      }
+
+      double floatValue;
+      if (double.TryParse(word, NumberStyles.Float, cultureInfo, out floatValue)) {
+        expression = new FloatPushExpression(floatValue);
+        return true;
+      }
+
+      bool booleanValue;
+      if (bool.TryParse(word, out booleanValue)) {
+        expression = new BooleanPushExpression(booleanValue);
+        return true;
+      }
+
+      expression = null;
+      return false;
+    }
+  }
+}
